import AbstractBlueprint from './Abstracts/AbstractBlueprint';
import AbstractConditionBlueprint from './Abstracts/AbstractConditionBlueprint';
import TextBlueprint from './TextBlueprint';
export declare const SLOT_PROPS = "$_slot_props";
export declare const SELF = "$_self";
export declare const LOOP = "loop";
export declare const LOOP_VALUE = "$_loop_value";
export default class ComponentBlueprint extends AbstractBlueprint {
    static create(...attributes: any[]): ComponentBlueprint;
    protected ref: string;
    protected key: string;
    protected refInFor: boolean;
    protected scopedSlots: AbstractBlueprint[];
    protected attributes: {};
    protected props: {};
    protected on: {};
    protected children: ComponentBlueprint[];
    protected classes: {};
    protected style: {};
    protected affect: string;
    protected bound: string[];
    protected loop: AbstractBlueprint | undefined;
    protected conditions: AbstractConditionBlueprint[];
    protected text: TextBlueprint | undefined;
    constructor(type: string);
    getBound(): string[];
    setBound(bound: string[]): this;
    getRef(): string;
    setRef(ref: string): this;
    setBindRef(ref: string): this;
    getKey(): string;
    setKey(key: string): this;
    setBindKey(key: string): this;
    getRefInFor(): boolean;
    setRefInFor(refInFor: boolean): this;
    getScopedSlots(): AbstractBlueprint[];
    setScopedSlots(scopedSlots: Function): this;
    slotProp(ref: string): string;
    getAttributes(): {};
    setAttributes(attributes: {}): this;
    setBindAttributes(attributes: {}): this;
    addBindAttribute(key: string, value: string): this;
    addBindAttributes(attributes: {}): this;
    addAttributes(attributes: {}): this;
    getProps(): {};
    setProps(props: {}): this;
    setBindProps(props: {}): this;
    addProps(props: {}): this;
    addBindProps(props: {}): this;
    addBindProp(key: string, value: any): this;
    getOn(): {};
    setOn(on: {}): this;
    addOn(on: {}): this;
    getChildren(): ComponentBlueprint[];
    setChildren(children: ComponentBlueprint[]): this;
    getClasses(): {};
    setClasses(classes: {}): this;
    setBindClasses(ref: string): this;
    getStyle(): {};
    setStyle(style: Array<{}>): this;
    getLoop(): AbstractBlueprint | undefined;
    setLoop(loop: AbstractBlueprint): this;
    getConditions(): AbstractConditionBlueprint[];
    setConditions(conditions: AbstractConditionBlueprint[]): this;
    addCondition(condition: AbstractConditionBlueprint): this;
    getAffect(): string;
    setAffect(affect: string): this;
    getText(): string | null;
    setText(text: string): this;
    setBindText(text: string): this;
    isBound(key: any): string | undefined;
    toObject(): any;
    protected addBound(bound: string): this;
}
