import ComponentBlueprint from '../../Blueprints/ComponentBlueprint';
import ComponentInterface from '../Contracts/ComponentInterface';
export default class AbstractComponent implements ComponentInterface {
    protected type: string;
    protected _blueprint: ComponentBlueprint;
    protected _children: AbstractComponent[];
    protected bindable: {
        prop: string;
        props: string;
        attribute: string;
        attributes: string;
    };
    protected constructor(type: any);
    getId(): string;
    getType(): string;
    setType(type: string): this;
    getBlueprint(): ComponentBlueprint;
    setBlueprint(blueprint: ComponentBlueprint): AbstractComponent;
    getChildren(): AbstractComponent[];
    setChildren(children: AbstractComponent[]): AbstractComponent;
    getBindable(): {
        prop: string;
        attributes: string;
        attribute: string;
        props: string;
    };
    setBindable(bindable: {
        prop: string;
        attributes: string;
        attribute: string;
        props: string;
    }): AbstractComponent;
    prop(key: string, value: string): AbstractComponent;
    props(props: {
        key: string;
        value: string;
    }): AbstractComponent;
    attribute(key: string, value: string): AbstractComponent;
    attributes(attributes: {
        key: string;
        value: string;
    }): AbstractComponent;
    children(children: AbstractComponent[]): AbstractComponent;
    scopedSlots(scopes: (scope: Function) => AbstractComponent[]): this;
    classes(classes: string | string[]): AbstractComponent;
    style(cssAttribute: string, value: string): AbstractComponent;
    styles(styles: Array<{
        cssAttribute: string;
        value: string;
    }>): AbstractComponent;
    key(key: string): this;
    ref(ref: string): this;
    refInFor(refInFor: true): this;
    affect(affect: string): this;
    on(event: string, callback: string): this;
    text(text: string): this;
    loop(iterable: string): this;
    if(condition: string): this;
    show(condition: string): this;
    clone(): ComponentInterface;
    toJson(): string;
    toObject(): object;
}
